void solve_CG(double enorm, int &nconv, double &diff,
               double *xq, double *u, double *b);
void solve_CG_init(double &rrp, double &rr, double *u,
     double *x, double *r, double *s, double *p, double *v);
void solve_CG_step(double &rrp, double &rr, double *u,
     double *x, double *r, double *s, double *p, double *v);

void opr_DdagD(double *v, double *u, double *w);
void opr_D(double *v, double *u, double *w);
void opr_H(double *v, double *u, double *w);
void mult_xp(double *v2, double *u, double *v1);
void mult_xm(double *v2, double *u, double *v1);
void mult_yp(double *v2, double *u, double *v1);
void mult_ym(double *v2, double *u, double *v1);
void mult_zp(double *v2, double *u, double *v1);
void mult_zm(double *v2, double *u, double *v1);
void mult_tp(double *v2, double *u, double *v1);
void mult_tm(double *v2, double *u, double *v1);

void set_src(int ic, int id,
             int ix, int iy, int iz, int it, double *v);

void setconst(int nv, double *v, double a);
void vecprd(int nv, double &a, double *v1, double *v2);
void normv(int nv, double &a, double *v);
void selfadd(int nv, double *v1, double *v2, double a);
void selfsprd(int nv, double *v, double a);
void spx(int nv, double *v,  double *w, double a);
void equate(int nv, double *v, double *w);
